/* ==== C-foogrid.c ==== */
/*  Part of the source of the program "Porrog", a roguelike game.
    Copyright (C) 2002-2003  Tom Barnes-Lawrence
    Current web address: www.angelfire.com/super2/duologue/
    Current email address: tomble@usermail.com
    Postal address: mind your own business

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <stdlib.h>
#include "C-foogrid.h"
#include "crash.h"
/* #include "C-2darray_P.h"private declarations */


foogrid *create_foogrid(int hgt,int wid, int tsize)
{
   foogrid *head=NULL;
   void *datablock=NULL;
   head=(foogrid *)malloc(sizeof(foogrid));
   if (NULL==head)
      crash(NO_MEM);
   datablock=(void *)malloc(tsize*hgt*wid);
   if (NULL==datablock)
      crash(NO_MEM);
   head->Xsize=wid;
   head->Ysize=hgt;
   head->Tsize=wid*hgt; /* That's right, isn't it? */
   head->Data=datablock;
   return head;
}
#define CAREFUL

long foogrid_idx(foogrid *array, int y, int x)
{
  long pos=(array->Xsize*y)+x;
  if (pos>=array->Tsize) /*Think that test is right*/
  {
     crash(OUT_OF_BOUNDS); /* Traps *dangerous* accesses */
  }
#ifdef CAREFUL
  if (x>=array->Xsize || y>=array->Ysize)
  {
     /* Traps accesses that would only cause logical errors (code that could
      produces *these* would likely produce the above in due course though)*/
     crash(OUT_OF_BOUNDS);
  }
#endif
  return pos;
}

void free_foogrid(foogrid *array)
{
   free(array->Data);
   free(array);
}
