/* ==== crash.c ==== */
/*  Part of the source of the program "Porrog", a roguelike game.
    Copyright (C) 2002-2003  Tom Barnes-Lawrence
    Current web address: www.angelfire.com/super2/duologue/
    Current email address: tomble@usermail.com
    Postal address: mind your own business

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


/* #include <stdio.h> included by ui.h???? */
#include <ncurses.h> /* Because we don't do it properly yet. */
#include "porrog_defs.h" /* EVERYTHING needs this now.*/
#include "crash.h"
#include "item_t.h"
#include "structures.h" /* needed for item_t def*/
#include "ui.h" /*We're doing it through curses now.*/


void crash(enum crashtype reason)
{
/*    fprintf(stderr,"\nDOH!\n Porrog has encountered an error!\n");
*/
    switch (reason)
    {
        case NO_MEM:
           msg_window("Couldn't allocate more memory!");
           /*Either the game has a memory leak, or\n your machine doesn't have enough memory installed.\n");
           */
           break;
        case INVALID_DIE_TYPE:
           msg_window("Tried to use an invalid die type.");
           /*Our RNG only supports D3, D4, D5, D6, D8, D10, D12, and D20 dice.\n");
           */
           break;
        case INVALID_ENVIRONMENT:
           msg_window("Porrog is unable to start in the environment supplied.");
           /*So, it didn't.\n");
           */
           break;
        case OUT_OF_BOUNDS:
           msg_window("Some thing was accessed outside its proper bounds.");
           /*This is a bug.\n");
           */
           break;
        case INCONSISTENT:
           msg_window("Some unknown, earlier error left inconsistent data we cant deal with.");
           break;
        case SCREEN_ERROR:
           msg_window("An error was encountered accessing the screen.");
           break;
        case IO_ERROR:
           msg_window("An IO error occurred. Somehow.");
           break;
        case FUNCTION_ERROR:
           msg_window("A specific function has gone wrong somehow.");
           break;
/*        default: */
           msg_window("The type of error is unknown! This is an error in itself!!!");
           break;
    }
    /*
    fprintf(stderr,"For this reason, Porrog has quit.\n");
    fprintf(stderr,"Well, unless the crash was down to you (such as invalid starting parameters),\nyou ought to let the author know.\nProbably.\n");
    */
    getch(); /* Wait for a key. */
    endwin();
    exit(1);
}
