/* ==== globals.c ==== */
/* Declarations for these will be in specific headers */


#include <stdlib.h>
#include "porrog_defs.h"
#include "C-foogrid.h"
#include "dXrng.h"
#include "item_t.h"
#include "structures.h"
#include "mapgen_types.h"
#include "player.h"


/* ---  dXrng.c stuff should be mostly private/static... --- */
/* ---  except the new dice array vars ! --- */

dXrng_roller *d4set[8]; /* 8d4 gives avg ~16 */
dXrng_roller *d6set[5]; /* 5d6 gives avg ~15 */
dXrng_roller *d8set[4]; /* 4d8 gives avg ~16 */
dXrng_roller *d10set[3]; /* 3d10 gives avg ~15 */
dXrng_roller *d12set[3]; /* 3d12 gives avg ~18 */
dXrng_roller *d20set[2]; /* 2d20 gives avg 20 */


/* --- Were in item.c --- */

itemtype_t *first_its[IG_LASTGROUP];
/* An array of pointers to initial item types */

int it_nums[IG_LASTGROUP];
/* The number of different types in each group */

char invletter_array[13];
/* Bits set in this array indicate letters that ARENT used */


/* --- Were in los.c --- */

char los_vistab[21*21];
/* Each element is 1 if visible, and 0 if not */

char los_blocktab[21*21];
/* Used in updating LOS each turn. Set up by init_los() (not yet implemented*/


/* --- Were in maparray.c --- */

foogrid *map;
/* The map array for current level (may change implementation) */

foogrid *tmap;
/* Array of pointers to tunnel sections */

itemtype_t markerobs[16];
/* Just used for testing. Will be removed later. */

roomdata_t room[217];
/* The array of room data structures */

area_t *firstarea=NULL;
/* Pointer to the first area of list*/


/* --- (memutils.c has only *static* vars) --- */

/* --- From monster.c --- */

mobtype_t *first_mt=NULL;
int mt_nums=0;

/* Will need structures to store each monster instance so we
   can actually find them all to move them... */
/* Will be changed to array of lists for each monster symbol */


/* --- Were in player.c --- */

player_t player;
/* The player character's data */


/* --- Were in ui.c --- */

char strbuf[160];
/* A buffer for sprintf() to write strings into */



/* --- Think that's all now --- */
