/* ==== enums.h ==== */
/*  Part of the source of the program "Porrog", a roguelike game.
    Copyright (C) 2002-2003  Tom Barnes-Lawrence
    Current web address: www.angelfire.com/super2/duologue/
    Current email address: tomble@usermail.com
    Postal address: mind your own business

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* Only has all the enumerated types. Depends on nothing else? */

typedef enum {
    PTL_PWALL, /* Permanent wall at the edge of the map*/
    PTL_ROCK, /* was PTL_TWALL*/
    PTL_HWALL, /* A horizontal perimeter wall (of a room)*/
    PTL_VWALL, /* " vertical    """""""*/
    PTL_CORNER,/* Corner of a room. Similar to PTL_PWALL.*/
    PTL_DOOR,
    PTL_ODOOR, /* A door that is open not closed. Doh.*/
    PTL_FLOOR,
    PTL_TUNNEL, /* Area of floor in a tunnel. Just for mapgen functions.*/
    PTL_RMID
} tile_t;

typedef enum {
   IG_WEAPON, /* Wieldables first */
   IG_RANGED,
   IG_MISSILE,

   IG_SUIT,  /* Wearables */
   IG_SHIELD,
   IG_HEADGEAR,
   IG_GLOVES,
   IG_FOOTWEAR,

   IG_RING, /*Including jewellery */
   IG_NECKWEAR,

   IG_SCROLL, /* Readables */
   IG_BOOK, /* spellbooks and mundane books together or not?? */

   IG_FOOD, /* Comestibles */
   IG_CORPSE,
   IG_CONDIMENT, /* Can be applied to other foods, thrown, etc */
   IG_POTION,

   IG_WAND, /* Zappables */
   IG_ROD,

   IG_TOOL, /* Generic tools */
   IG_CONTAINER,
   IG_STONE, /* Gemstones and rocks and pebbles and so on */
   IG_COINAGE, /* That everything??*/
   IG_LASTGROUP /* Marker! */
} itemgroup_t;

typedef enum {
   IG_WIELDABLES,
   IG_WEARABLES,
   IG_WEAPONS,
   IG_ARMOURS,
   IG_JEWELLERY,
   IG_READABLES,
   IG_COMESTIBLES,
   IG_ZAPPABLES,
   IG_VALUABLES,
   IG_ALLCLASES,
   IG_NOCLASSES
} itemclass_t; /* Used for, eg, stating what items a container can carry */
