/* ==== item_p.h ==== */
/*  Part of the source of the program "Porrog", a roguelike game.
    Copyright (C) 2002-2003  Tom Barnes-Lawrence
    Current web address: www.angelfire.com/super2/duologue/
    Current email address: tomble@usermail.com
    Postal address: mind your own business

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


/*extern itemtype_t *first_it; */
/* Where do these get declared? HERE!*/
extern itemtype_t *first_its[]; /* Replaces the above */
extern int it_nums[]; /* The number of different types in each group */

/* include C-foogrid.h first, then maparray.h, before this. */

void i_init();
/* Creates all the item types. Only called once. */

void p_init_inv();
/* Sets up things like the inventory letter stuff */

char first_unused_invletter();
/* Returns the first letter available for use */

void tag_invletter_usage(char letter,int discarding);
/* Sets that letter is or isn't available for use.
   If  discarding, letter becomes available.
   else isn't available any more. */

void add_item(foogrid *map,int x, int y,itemtype_t *otype);
/* Places a new instance of otype at the position given */

void new_itemtype(itemtype_t *space,char symbol,char *name, itemgroup_t type);
/* Creates a new type of object, puts it into the space
   allocated by space. No extra space is allocated for name */

void push_itype(itemgroup_t group,char *name);
/* higher level function in creating item types. Places the newly
   created type on one of a global stack of items
   (one stack per group). */

/*
item_t *skim_item(foogrid *map,int x,int y);
 Removes the top item from any heap on the floor. Returns that
   item alone (with item->Next==NULL) */
/* CHANGED TO: */
void skim_item(foogrid *map, int x,int y,item_t *item);
/* Looks through the heap on the floor at x,y, finds item and
   removes it. If item isn't there (or there's no heap) CRASHES. */

void place_item(foogrid *map,int x,int y,item_t *item);
/* Puts a single item at a place on the floor */

void describe_item(char *space, item_t *item);
/* Gives the description (as in 57 arrows +1 or whatever) of item printed
   into space */

int combine_items(item_t *item, item_t *group);
/* If an item in group matches item in type, enchantment, egoness,
   and of course basic stackability (things like containers cant stack!)
   then simply adds the number of item to the number of the item found
   in group. At which point, I suppose item simply gets freed as
   two item structures get combined into 1.
   If the items weren't stackable, then item goes to the top of group
   instead.
   If the items were combined, return 1. If there was no combining
   then returns 0.
   This is important for when user picks up an item, as inventory
   letters get assigned to things.
   Ah, but what happens to the pointer to the group? If item goes
   on top, then the head pointer wants to be updated :P */

