/* ==== mapgen_types.h ==== */
/*  Part of the source of the program "Porrog", a roguelike game.
    Copyright (C) 2002-2003  Tom Barnes-Lawrence
    Current web address: www.angelfire.com/super2/duologue/
    Current email address: tomble@usermail.com
    Postal address: mind your own business

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* Structures used in map generation (also used by AI) */


struct area_t {
   int Firstroom; /* Because we'll only store a bounded number of
      rooms, which we'll stick in an array. */
   struct tunnellist_t *Firsttunnel;
   int Size; /* Number of rooms in the area (starts as 1)*/
   struct area_t *Nextarea;/*Because we want a list of em */
};
typedef struct area_t area_t;

struct tunnellist_t {
   int Xstart,Ystart;
   int Xend,Yend;
   area_t *Area;
   struct tunnellist_t *Nexttunnel;
};
typedef struct tunnellist_t tunnellist_t;

typedef enum {
   FACE_N,
   FACE_E,
   FACE_S,
   FACE_W
} direction_t; /* Should be defined elsewhere? */

struct entrance_t {
   int Xcoord,Ycoord;
   direction_t Outfacing; /* the direction you face if you face this
        door from inside the room XP */
   struct entrance_t *Nextentrance;
};
typedef struct entrance_t entrance_t;

typedef struct {
   int Xcentre,Ycentre; /*Hey, seems we *can* say it this way.*/
   int Xstart,Ystart; /*Just so we don't have to keep calculating it*/
   int Width, Height;
   entrance_t *Entrancelist;
   area_t *Area;
   int Nextroom;
} roomdata_t;


