/* ==== main.c ==== */
/*  Part of the source of the program "Porrog", a roguelike game.
    Copyright (C) 2002-2003  Tom Barnes-Lawrence
    Current web address: www.angelfire.com/super2/duologue/
    Current email address: tomble@usermail.com
    Postal address: mind your own business

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include "porrog_defs.h"
#include <ncurses.h>
#include <unistd.h>
#include <stddef.h>
#include "C-foogrid.h" /* Used for foogrid*/
#include "mapgen_types.h"
#include "maparray.h"
#include "crash.h"
#include "dXrng.h"
#include "memutils.h"
#include "item_t.h"
#include "structures.h"
#include "item_p.h"
#include "player.h"
#include "monster.h"
#include "version.h"
#include "ui.h"
#include "apply.h"

mobtype_t *pm_type; /* A base type for player monster.*/
monster_t *playermob; /* A player data pointer */

int ctrl_loop(); /* Is in ctrl.c, but not worth making a header for ;) */


int main(int argc, char **argv)
{
    /*
    int x=(MAPWID/2)-25,y=(MAPHGT/2)-10,quit=0;
    char k; */
    int exit_status;

    /* Set up curses stuff */
    if (initscr()==NULL)
    { /* crash(SCREEN_ERROR); crash() now goes through curses! */
      fprintf(stderr,"Yarg! Porrog couldn't initialise the terminal display! Quitting.\n");
      exit(1);
    }
    notimeout(stdscr, 1);
    noecho();
    cbreak();

    /* Set up our stuff */
    initialise_dXrng(); /* done *after* curses starts as it may use crash()*/
    i_init(); /* make_map places objects */
    m_init();

    /* The first map. */
    make_map();
    /* Player now has his own global variable...
    pm_type=(mobtype_t *)malloc(sizeof(mobtype_t));
    playermob=(monster_t *)malloc(sizeof(monster_t));
    new_mobtype(pm_type,'@',"Player","This is you!");
    playermob=add_mob(map,(MAPHGT/2),(MAPWID/2),pm_type); */
    init_player(map,(MAPHGT/2),(MAPWID/2));
    p_init_inv();

    show_messages("Welcome to Porrog!");

    exit_status=ctrl_loop();
    /* Now does pretty much everything */

    endwin();
    printf("Exiting.\n");/* Should say reason for exiting */
    printf("%ld unfreed allocations made.\n",check_allocs());
    exit(0);
}
