/* ==== mapgen.c ==== */
/* Adapted from maparray.c, contains the generator's helper functions */
/*  Part of the source of the program "Porrog", a roguelike game.
    Copyright (C) 2002-2003  Tom Barnes-Lawrence
    Current web address: www.angelfire.com/super2/duologue/
    Current email address: tomble@usermail.com
    Postal address: mind your own business

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <stdlib.h>
/* #include <ncurses.h> Should be removed when debugging syms removed*/
#include "porrog_defs.h"
#include "C-foogrid.h"
#include "memutils.h"
#include "item_t.h"
#include "structures.h"
#include "mapgen_types.h"
#include "maparray.h" /*We need this, but maybe just for the #defines*/
#include "mg_utils.h"
#include "ajoin.h"
#include "item_p.h"
#include "monster.h"
#include "crash.h"
#include "dXrng.h"
#include "ui.h" /* For error messages, which really ought to
                   be in crash.h */

/*foogrid *map;
foogrid *tmap;
itemtype_t markerobs[16]; Just for testing.
roomdata_t room[217];  Unfortunately now global X(
area_t *firstarea=NULL; Pointer to the first area of list
All now in globals.c */
extern foogrid  *tmap;
extern area_t   *firstarea;



int pick_room(int totalrooms)
{
    int roomno,count,seen;
    static dXrng_roller *d12=NULL;
    static dXrng_roller *d20=NULL;
    if (NULL==d12){d12=new_dX(12);d20=new_dX(20);}
    count=(totalrooms*((12*roll_dX(d20))+roll_dX(d12))/240);
    /* HOPEFULLY count should get truncated such that count < totalrooms.*/
    /* If not, we will likely get an out of bounds. Check, in case. */
    if (count>=totalrooms) show_messages("Picked room higher than totalrooms");
    for (roomno=-1,seen=0;seen<=count;roomno++,seen+=(room[roomno].Xcentre!=-1)?1:0);
    if (roomno>216||roomno==-1) show_messages("Picked impossible room");
    if (room[roomno].Xcentre==-1) show_messages("Picked unmade room");
    /* free(d12);free(d20); Whoops! Mustn't forget that.*/
    return(roomno);
    /* Kept as a reminder of how I'm liable to program whilst too tired
    for (tries=0,roomno=218;tries<10&&roomno>216;tries++)
        roomno=(12*roll_dX(d20))+roll_dX(d12);
    if (roomno>216||room[roomno].Xcentre==-1)
    { that was no good, lets try a different way
       for (tries=0,count=0;tries<1000 && count>=totalrooms;tries++)
           count=(12*roll_dX(d20))+roll_dX(d12);
       if (count>=totalrooms) count=0;  Ah fudge it 
       for (roomno=0,seen=0;seen<count;roomno++)
           seen+=(room[roomno].Xcentre!=-1)?1:0;  Just to be sure...
       roomno should now point to the count_th actual room
       if (roomno>216) crash(OUT_OF_BOUNDS); BIG foobar!!
    }
    return(roomno);
    */
}

int pick_room_from_area(area_t *area)
{
    /* Much the same as pick_room()*/
    int roomno,count,seen,totalrooms=area->Size;
    static dXrng_roller *d12=NULL;
    static dXrng_roller *d20=NULL;
    if (NULL==d12){d12=new_dX(12);d20=new_dX(20);}
    count=(totalrooms*((12*roll_dX(d20))+roll_dX(d12))/240);
    if (count>=totalrooms) crash(OUT_OF_BOUNDS);
    for (roomno=0,seen=0;seen<count;roomno=room[roomno].Nextroom)
        seen+=(room[roomno].Xcentre!=-1)?1:0;
    if (roomno>216||-1==roomno) crash(OUT_OF_BOUNDS);
    /* Presumably if we get a -1, it should crash anyway??*/
    if(room[roomno].Xcentre==-1) crash(OUT_OF_BOUNDS);
    return(roomno);
}

/* 
void attempt_joining(int source, int target)
{
    int found;   any rooms we come across on the way
    direction_t dir;  Direction chosen for tunnels
    int x,y;   temporary vars for starting tunnels
    int xstart,xend,ystart,yend;   Define points for doors
    int px,py;   temporary vars for probing locations
    area_t *sourcearea=room[source].Area;
    area_t *probearea;
    int sx,sy,tx,ty;    Centres of rooms 
    int sw,sh,tw,th;    Dimensions of rooms
    int sx1,sy1,sx2,sy2,tx1,ty1,tx2,ty2;   Boundaries of rooms
    maploc_t *mapstart=map->Data;
    sx=room[source].Xcentre;sy=room[source].Ycentre;
    tx=room[target].Xcentre;ty=room[target].Ycentre;

    sw=room[source].Width;sh=room[source].Height;
    tw=room[target].Width;th=room[target].Height;
    sx1=room[source].Xstart;sx2=sx1+sw-1;
    sy1=room[source].Ystart;sy2=sy1+sh-1;

    tx1=room[target].Xstart;tx2=tx1+tw-1;
    ty1=room[target].Ystart;ty2=ty1+th-1;
       2 rooms must have totaly non-overlapping coordinates
       in AT LEAST one dimension.
       Assuming they're separated in the Y axis:

       +-----+   #        +--+  #     +--+
       |     |   #        |  |  #     |  |
       +-----+   #        +--+  #     +--+
                 #              #
         +-+     # +--+         #   +--+
         | |     # |  |         #   |  |
         +-+     # +--+         #   +--+
      #####################################
         +-+     # +--+         #   +--+
         | |     # |  |         #   |  |
         +-+     # +--+         #   +--+
                 #              #
       +-----+   #        +--+  #     +--+
       |     |   #        |  |  #     |  |
       +-----+   #        +--+  #     +--+
     #######################################
     Are the only possibilities.
     Of course, they could be separated in the X axis
     instead, in which case you would have those
     rotated 90 degrees.
    # If separated by Y, sy2<ty1 || ty2<sy1
    #  If separated by X, sx2<tx1 || tx2<sx1
    if (sy2-1<ty1+1||ty2-1<sy1+1)  separated in Y axis
    {
       if (sx2-1<tx1+1||tx2-1<sx1+1)  separated in X too!
       {
          addch('/');refresh();
          This one the most serious! Tunnels with a corner
       } else {
          addch('|');refresh();
         hey! We can just make 1 vertical tunnel? Unless
          the overlap is too small, which could only happen
          in the *partial* overlap cases, in which case we treat
          as "separated in X"
          #if (sw<tw) x=sx; Because source is narrower
          #else x=tx; That only works if one is within t'other!
          xstart=MAX(sx1,tx1)+1;xend=MIN(sx2,tx2)-1;
          x=(xstart+xend)/2;
          dir=(sy<ty)?FACE_S:FACE_N;
          y=(FACE_N==dir)?sy1:sy2;  WAS FACE_N
          py=probe_path(x,y,dir); This *might* be an untunnelable bit!
          If it's the edge of the map... Hmm, that shouldn't happen here.
          If it's the corner of a room, then if it's in sourcearea,
          that still counts as part of the room.
          If it's the corner of a room *not* in sourcearea, we can't
          do anything with it!!! Can we? 
          All this stuff should be in a further function.
          probearea=find_area(x,py);
          if(probearea==NULL)
          {
             return;
          }
          if (sourcearea!=probearea)
          {
             build_tunnel(sourcearea,x,y,x,py);
             merge_areas(sourcearea,probearea);
             return;
          }
          if ((mapstart+foogrid_idx(map,y,x))->Tiletype==PTL_NSTUNNEL||
             (mapstart+foogrid_idx(map,y,x))->Tiletype==PTL_WETUNNEL)
          { #Ah. Well we can't do anything with that. Keep looking till
            #we hit a room. If that room is one of ours, call
            #attempt_joining(find_room(x,py),target); return;
            #If it is not one of ours, er, Hmm.
          }
       }
    } else {  cant be separated in Y axis, cutting out 2 options
       # yet again, we should hopefully be able to just make
       #  a single horizontal tunnel! Perhaps. If not, we treat
       # as "separated in Y"
       addch('-');refresh();
         # if (sh<th) y=sy;
         #else y=ty;  Should be a ?:;
       ystart=MAX(sy1+1,ty1+1);yend=MIN(sy2-1,ty2-1);
       y=(ystart+yend)/2;
       dir=(sx<tx)?FACE_E:FACE_W;
       x=(FACE_W==dir)?sx1:sx2; WAS FACE_W
       px=probe_path(x,y,dir);
       if(px>MAPWID-2||px<2) crash(OUT_OF_BOUNDS);
       probearea=find_area(px,y);
       if(probearea==NULL)return;
       if (sourcearea!=probearea)
       {
           build_tunnel(sourcearea,x,y,px,y);
           merge_areas(sourcearea,probearea);
           return;
       }
    }
     we want to try doing the "do this but with different source"
       thing when appropriate; for the moment, we'll just recurse.
       Later will change that to iterate (for speed)
}
*/

int probe_path(int x,int y,direction_t direction)
{
    int crs;
    maploc_t *mapstart=map->Data;
    switch(direction)
    {
        case FACE_N:
          for(crs=y-1;crs>1;crs--)
             if ((mapstart+FOOGRID_IDX(map,crs,x))->Tiletype!=PTL_ROCK||(mapstart+FOOGRID_IDX(map,crs,x-1))->Tiletype==PTL_TUNNEL||(mapstart+FOOGRID_IDX(map,crs,x+1))->Tiletype==PTL_TUNNEL)
                break;
          if(crs==y)crash(NO_MEM);
          break;
        case FACE_E:
          for(crs=x+1;crs<MAPWID;crs++)
             if ((mapstart+FOOGRID_IDX(map,y,crs))->Tiletype!=PTL_ROCK||(mapstart+FOOGRID_IDX(map,y-1,crs))->Tiletype==PTL_TUNNEL||(mapstart+FOOGRID_IDX(map,y+1,crs))->Tiletype==PTL_TUNNEL)
                break;
          break;
        case FACE_S:
          for(crs=y+1;crs<MAPHGT;crs++)
             if ((mapstart+FOOGRID_IDX(map,crs,x))->Tiletype!=PTL_ROCK||(mapstart+FOOGRID_IDX(map,crs,x-1))->Tiletype==PTL_TUNNEL||(mapstart+FOOGRID_IDX(map,crs,x+1))->Tiletype==PTL_TUNNEL)
                break;
          break;
        case FACE_W:
          for(crs=x-1;crs>1;crs--)
             if ((mapstart+FOOGRID_IDX(map,y,crs))->Tiletype!=PTL_ROCK||(mapstart+FOOGRID_IDX(map,y-1,crs))->Tiletype==PTL_TUNNEL||(mapstart+FOOGRID_IDX(map,y+1,crs))->Tiletype==PTL_TUNNEL)
                break;
          break;
        default:
          crash(-1); /*Should find a better value!*/
    }
    return(crs);
    /* Hey, that wasn't too painful!*/
    /* DOH!!! Need to check for tunnels either side of path.*/
}

void build_tunnel(area_t *area, int xstart, int ystart, int xend, int yend)
{
    tunnellist_t *thissection;
    int x,y;
    maploc_t *mapstart=map->Data;
    tunnellist_t **tmapstart=tmap->Data; /*Newly added*/
    direction_t dir;
    thissection=(tunnellist_t *)counting_malloc(sizeof(tunnellist_t));
    thissection->Xstart=xstart;thissection->Ystart=ystart;
    thissection->Xend=xend;thissection->Yend=yend;
    /* Ah. This upsets find_area(). which assumes start<=end. Hard to change*/
    if(xstart>xend){thissection->Xstart=xend; thissection->Xend=xstart;}
    if(ystart>yend){thissection->Ystart=yend; thissection->Yend=ystart;}
    thissection->Area=area;
    thissection->Nexttunnel=area->Firsttunnel;area->Firsttunnel=thissection;

    if(xstart!=xend && ystart!=yend)
    {
      sprintf(strbuf,"X: %d Y: %d x: %d y: %d Not a straight line tunnel",xstart,ystart,xend,yend);
      show_messages(strbuf);
      crash(OUT_OF_BOUNDS);
    }
      /* Means that the tunnel is not orthogonal*/
    if (xstart<xend) dir=FACE_E;
    else if (xstart>xend) dir=FACE_W;
    else if (ystart<yend) dir=FACE_S;
    else dir=FACE_N;
    switch(dir)
    {
        case FACE_N:
          x=xstart;
          for(y=ystart;y>=yend;y--)
          {
             (mapstart+FOOGRID_IDX(map,y,x))->Tiletype=PTL_TUNNEL;
             *(tmapstart+FOOGRID_IDX(tmap,y,x))=thissection;
          }
          break;
        case FACE_E:
          y=ystart;
          for(x=xstart;x<=xend;x++)
          {
             (mapstart+FOOGRID_IDX(map,y,x))->Tiletype=PTL_TUNNEL;
             *(tmapstart+FOOGRID_IDX(tmap,y,x))=thissection;
          }
          break;
        case FACE_S:
          x=xstart;
          for(y=ystart;y<=yend;y++)
          {
             (mapstart+FOOGRID_IDX(map,y,x))->Tiletype=PTL_TUNNEL;
             *(tmapstart+FOOGRID_IDX(tmap,y,x))=thissection;
          }
          break;
        case FACE_W:
          y=ystart;
          for(x=xstart;x>=xend;x--)
          {
             (mapstart+FOOGRID_IDX(map,y,x))->Tiletype=PTL_TUNNEL;
             *(tmapstart+FOOGRID_IDX(tmap,y,x))=thissection;
          }
          break;
    }
}

void merge_areas(area_t *area1, area_t *area2)
{
   /* This *REQUIRES* that room[] is GLOBAL. The problem is, that
     means that unless we create it with malloc(), that array is
     going to just sit around the whole time whether we need it or not*/
   int rlist;
   tunnellist_t *tun;
   area_t *next;
   area_t *scan;
   if (area1==area2) return; /*Nothing to do!*/
   if (NULL==area1)
   {
     show_messages("area1 is null!");
     crash(INCONSISTENT);
   }
   if (NULL==area2)
   {
     show_messages("area2 is null!");
     crash(INCONSISTENT);
   }
   for (rlist=area1->Firstroom;room[rlist].Nextroom!=-1;rlist=room[rlist].Nextroom)
      room[rlist].Area=area2;
   /*Now we have the end of list 1.*/
   room[rlist].Area=area2; /*I think we need that again? */
   room[rlist].Nextroom=area2->Firstroom;

   /*I think that mebbe area1 might not have any tunnel??
    Either, way, a segfault happens here!*/
   for (tun=area1->Firsttunnel;tun->Nexttunnel!=NULL;tun=tun->Nexttunnel)
   {
      tun->Area=area2;
   }
   tun->Area=area2; /*again, we repeat that */
   tun->Nexttunnel=area2->Firsttunnel;

   area2->Firstroom=area1->Firstroom;
   area2->Firsttunnel=area1->Firsttunnel;
   area2->Size+=area1->Size;
   /* NOW we want to remove area1 from the area list. OUCH!
     THIS MUST BE DONE!*/
   next=area1->Nextarea; /* The bit we use to replace area1 in the list*/
   if (firstarea==area1)
   { /* The exception to the rule: area1 is head of the list.*/
      firstarea=next; /* That's all folks!*/
   } else {
     for(scan=firstarea;scan->Nextarea!=area1;scan=scan->Nextarea)
     {
        if(scan->Nextarea==NULL)
         {show_messages("Found end of area list!");}
     }
     /*We've now found scan->Nextarea==area1. So we splice here.*/
     scan->Nextarea=next;
   } /*area1 should now be out of the list. Yes?*/
   counting_free(area1); /*we *can* do that, right? */
   /*Hopefully there should be no pointers to area1 left now.*/
}

/* CHANGED to now only get area of tunnels (due to a rare bug
  if get_area found a room in front of the path when a probe
  was actually stopped by a tunnel next to it */
area_t *find_area(int x, int y)
{
   area_t *testarea=firstarea;
   tunnellist_t *testtun;
   maploc_t *mapstart=map->Data;
/* tunnellist_t **tmapstart=tmap->Data;   Will be used soon.*/
   if ((mapstart+FOOGRID_IDX(map,y,x))->Tiletype==PTL_PWALL)
   {
      show_messages("Permanent wall found!!");
      crash(OUT_OF_BOUNDS);
   }
   if ((mapstart+FOOGRID_IDX(map,y,x))->Tiletype==PTL_TUNNEL)
   { /* This is a tunnel. Ah. we have to search all tunnel sections..*/
     for(;testarea!=NULL;testarea=testarea->Nextarea)
     {
        if(testarea==NULL) crash(INCONSISTENT);
        for(testtun=testarea->Firsttunnel;testtun!=NULL;testtun=testtun->Nexttunnel)
        {
          if (testtun==NULL) crash(INCONSISTENT);
          if(testtun->Xstart<=x && testtun->Xend>=x &&
            testtun->Ystart<=y && testtun->Yend>=y) /*This'll do*/
             return(testtun->Area); /*Here you go!*/
        }
     }
     /*Urp! Didn't find anything. Major foobar!!!
     It looks like this doesn't happen *any more*... */
     crash(INCONSISTENT); return(NULL); /*To shut up gcc*/
   } else {
    /* Technically it might not be, but we'll assume it's part of a room.*/
    /* This can now be given from room[find_room(x,y)]->Area;
       So we should remove this? YES!! Now just returns NULL
       if no tunnel found. */
     return(NULL);
   }
}

int find_room(int x,int y)
{
   int r;
   for (r=0;r<217;r++)
   {
       if(room[r].Xcentre!=-1 &&
       (room[r].Xstart<=x && room[r].Xstart+room[r].Width-1>=x &&
        room[r].Ystart<=y && room[r].Ystart+room[r].Height-1 >=y))
            return(r);
   }
   crash(INCONSISTENT);
   return(-1); /*Not part of any room we can find!*/
}

void add_room_items(int roomno)
{
   /* NB: Until I track down the glitch that pops up in the
     first map generated, I'm NOT going to do anything that would
     cause that map to change.
     That includes using ANY sort of random numbers in any new functions.
     So for now, this function will not be remotely random.*/
   int x,y,count=0,pick=0;
   itemtype_t *picktype; /* Pick a type. */
   itemgroup_t group; /* From a group. */
   if (roomno==-1|| room[roomno].Xcentre==-1) return; /* Hmm */
   x=room[roomno].Xstart+1 + (( (room[roomno].Width-2) *roomno)/217);
/* y=room[roomno].Ycentre+1; */
   y=room[roomno].Ystart+1 + (( (room[roomno].Height-2) *roomno)/217);
   group=roomno%IG_LASTGROUP;
   if (group==IG_CORPSE) group=(roomno%3)?IG_FOOD:IG_STONE;
   /* corpses are only generated from monsters. We've got none yet.*/
   /* 
   for(picktype=first_it;picktype!=NULL;picktype=picktype->Next)
   {
      if (picktype->Type==group)  Potential match.
      {
         flag=1;
         count++;
         chosen=picktype;
         if(count>(roomno/8)) break;
      } else if (flag==1) break;
   }
   */
   pick=(it_nums[group]*roomno)/217;
   for(picktype=first_its[group];count<pick;count++,picktype=picktype->Next);
   if (picktype==NULL) crash(OUT_OF_BOUNDS);
   add_item(map,x,y,picktype);
}

void add_room_mobs(int roomno)
{
   int x,y,count=0,pick=0;
   mobtype_t *picktype;
   if (roomno==-1|| room[roomno].Xcentre==-1) return; /* Hmm */
   x=room[roomno].Xstart+1 + (( (room[roomno].Width-2) *roomno)/217);
   y=room[roomno].Ystart+1 + (( (room[roomno].Height-2) *roomno)/217);
   pick=(mt_nums*roomno)/217;
   for(picktype=first_mt;count<pick;count++,picktype=picktype->Next);
   if(picktype==NULL) crash(FUNCTION_ERROR);
   add_mob(map,x,y,picktype);
}

area_t *choose_small_area()
{
   int minsize=218;   /*Min size found*/
   area_t *carea; /* area with that size*/
   area_t *tarea; /*Area we are testing.*/
   static dXrng_roller *d4=NULL;
   if (NULL==d4) d4=new_dX(4);
   for (tarea=firstarea;tarea!=NULL;tarea=tarea->Nextarea)
   {
      if(tarea->Size==1)
      {
         minsize=1;carea=tarea;
         if (!roll_dX(d4))break; /*  We might stop looking here*/
      }
      if(tarea->Size<minsize)
      {
         minsize=tarea->Size;
         carea=tarea;
      }
   }
   return(carea);
}

void free_tunnels(tunnellist_t *tl)
{
    tunnellist_t *next;
    for(;tl!=NULL;next=tl->Nexttunnel,counting_free(tl),tl=next);
}
void free_areas()
{
    /*There should only be one area, firstarea.*/
    area_t *area;
    area_t *next;
    for(area=firstarea;area!=NULL;next=area->Nextarea,counting_free(area),area=next)
    {
       free_tunnels(area->Firsttunnel);
    }
}
